/*
  Analog input, analog output, serial output
 
*/

// These constants won't change.  They're used to give names
// to the pins used:
const int analogInPin = 0;  // Analog input pin that the potentiometer is attached to
const int analogOutPin = 9; // Analog output pin that the LED is attached to

int sensorValue = 0;        // value read from the pot
int outputValue = 0;        // value output to the PWM (analog out)

int sensorValuesArray[200];
unsigned long t0, timeArray[200];
int n;


void pwm_config(int freqId) {
  if (freqId<1 || freqId>5) {
    Serial.print("ERR: invalid pwm freqId - not in 1..5");
    return;
  }
  int prescalerVal= 0x07; // clear the last 3bits mask
  TCCR1B &= ~prescalerVal;
  prescalerVal= freqId;
  TCCR1B |= prescalerVal;

  // if Arduino MEGA then timer 1B -> 2B
  /*
  TCCR2B &= ~prescalerVal;
  prescalerVal= freqId;
  TCCR2B |= prescalerVal;
  */
}


void setup() {
  // initialize serial communications at 9600 bps:
  Serial.begin(9600); 
  //Serial.begin(115200);
}


int freqId= 0;

void loop() {

  Serial.print("%% ----- freqId= "); Serial.println(freqId);
  if (freqId > 0) pwm_config(freqId);
  freqId++; if (freqId > 5) freqId=1; // loop 1..5
  //delay(1000); // 1000 msec = 1 sec
  Serial.print("%% ----- TCCR1B= "); Serial.println(TCCR1B);
  //Serial.print("%% ----- TCCR2B= "); Serial.println(TCCR2B);
  
  // read the analog in value:
  t0= micros();
  //analogWrite(analogOutPin, 255);           
  analogWrite(analogOutPin, 127);           
  for (n=0; n<200; n+=2) {
    sensorValuesArray[n]= analogRead(0);
    timeArray[n]= micros();
    sensorValuesArray[n+1]= analogRead(1);
    timeArray[n+1]= micros();
  }
  analogWrite(analogOutPin, 0);           
  
  Serial.print("%% ----- start time [us]= ");
  Serial.println(t0);

  Serial.print("x"); Serial.print(freqId-1); Serial.println("=[");
  for (n=0; n<200; n+=2) {
    Serial.print(" "); //v1=");
    Serial.print(sensorValuesArray[n]);
    Serial.print(" "); //v2=");
    Serial.print(sensorValuesArray[n+1]);
    Serial.print(" "); //t1=");
    Serial.print(timeArray[n]);
    Serial.print(" "); //t2=");
    Serial.println(timeArray[n+1]);
  }
  Serial.println("];");

  // wait 10 milliseconds before the next loop
  // for the analog-to-digital converter to settle
  // after the last reading:
  delay(10);                     
}

